/*--------------------------------------------------------------
    trackpeerd - peer tracking agent
    basic communication module    comm.h
      Written by  H.Goto, Jan 2005
      Modified by H.Goto, Mar 2005
--------------------------------------------------------------*/

/*----------------------------------------------------------------------
  Copyright (C) 2005  Hideaki Goto

  All Rights Reserved.

  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions:

  The above copyright notice and this permission notice shall be
  included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR
  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Except as contained in this notice, the name(s) of the copyright
  holder(s) shall not be used in advertising or otherwise to promote
  the sale, use or other dealings in this Software without prior
  written authorization of the copyright holder(s).
----------------------------------------------------------------------*/

#ifndef	_comm_h
#define	_comm_h

#include	<sys/types.h>
#include	<sys/time.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>

#ifdef	__cplusplus
extern "C" {
#endif

int	get_addr_port(char *addrstr, in_addr_t *addr, uint16_t *port);
int	get_addr_mask(char *addrstr, in_addr_t *addr, in_addr_t *mask);
int	ReceiveData(int sock, char *buf, int len, time_t timeout);
int	SendData(int sock, char *buf, int len, time_t timeout);
int	ReceiveLine(int sock, char *buf, int buflen, time_t timeout);
int	SendLine(int sock, char *msg, time_t timeout);
int	SendLineLF(int sock, char *msg, time_t timeout);

#ifdef	__cplusplus
}
#endif

#endif	/* _comm_h */
