/*--------------------------------------------------------------
    trackpeerd - peer tracking agent
    MAC table monitoring module   macmon.h
      Written by  H.Goto, Sep 2005
      http://www.sc.isc.tohoku.ac.jp/~hgot/
--------------------------------------------------------------*/

/*----------------------------------------------------------------------
  Copyright (C) 2005  Hideaki Goto

  All Rights Reserved.

  Permission is hereby granted, free of charge, to any person obtaining
  a copy of this software and associated documentation files (the
  "Software"), to deal in the Software without restriction, including
  without limitation the rights to use, copy, modify, merge, publish,
  distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to
  the following conditions:

  The above copyright notice and this permission notice shall be
  included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR
  ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

  Except as contained in this notice, the name(s) of the copyright
  holder(s) shall not be used in advertising or otherwise to promote
  the sale, use or other dealings in this Software without prior
  written authorization of the copyright holder(s).
----------------------------------------------------------------------*/

#ifndef	_macmon_h
#define	_macmon_h

#include	<net/ethernet.h>
#include	<netinet/ip.h>
#define	__FAVOR_BSD
#include	<netinet/tcp.h>
#include	<syslog.h>

#define	SYSLOG_FACILITY	LOG_LOCAL4
#define	SYSLOG_LEVEL	LOG_INFO
#define	SYSLOG_PRIORITY	(SYSLOG_FACILITY | SYSLOG_LEVEL)


typedef struct {
	time_t		lasttime;	/* time (sec) of the last packet in UTC */
	in_addr_t	ip_src;
	struct ether_addr	mac_src;
	char		devname[16];
} MACTable_item;


#ifdef  __cplusplus
extern "C" {
#endif

void	*macmon_thread(void *pargs);

#ifdef  __cplusplus
}
#endif

#endif	/* _macmon_h */
